#include "lab.h"
#include <mkl_cblas.h> //TODO: Include this line for mkl

// y' <- x'*A
void vxm_ref(const int m, const int n, const double* A,const double* x, double* y){
	int i, j;
	
	for(i=0; i<n; i++){
		y[i] = 0.0;
		for(j=0; j<m; j++)
			//TODO: Multiply x_j with a_ji and add the result to y_i
			y[i] += A[i+j*n] * x[j];
	}
}

// y' <- x'*A
void vxm_order(const int m, const int n, const double* A,const double* x, double* y){
	int i, j;

	//TODO: Initialize every y[i] with the first value!
	for(i=0; i<n; i++)
		y[i] = A[i] * x[0];

	//TODO: Calculate the vector-matrix-product by accessing the matrix consecutively!
	for(j=1; j<m; j++)
		for(i=0; i<n; i++)
			y[i] += A[i+j*n] * x[j];
}

// y' <- x'*A
/*TODO: Modifiy this function head and give the compiler a hint that there wont 
  be pointer aliasing in this function!*/
void vxm_restrict(const int m, const int n, const double* restrict A,const double* restrict x, double* restrict y){
	int i, j, offset;
	
	for(i=0; i<n; i++){
		y[i] = 0.0;
		for(j=0; j<m; j++)
			//TODO: Uncomment this line
			y[i] += A[i+j*n] * x[j];
	}
}

void vxm_mkl(int m, int n, const double* A, const double* x, double* y){

	const double alpha = 1;
	const double beta = 0;
	const double incx = 1;
	const double incy = 1;

  //TODO: Use CBLAS such that cblas_dgemv() from the MKL is called and performs a vxm!
	cblas_dgemv(CblasRowMajor, CblasTrans, m, n, alpha, A, m, x, incx, beta, y, incy);
}

